// combine.cpp

#include <graphics.h>
#include <fstream>
#include <sstream>
#include <string>

#include "display.h"
#include "audio.h"

using namespace std;

ifstream setting_file_in;
ofstream setting_file_out;
ifstream lgsetting_file_in;
ofstream lgsetting_file_out;
ifstream highscore_file_in;
ofstream highscore_file_out;

string setting_file_name="combine.ini";
string lgsetting_file_name="lg\\zh_cn.lg";
string highscore_file_name="highscore.db";

const int maxcbd=63;
const int maxhighscore=1000;
const int maxcheat=17;
const int maxspeed=20;
int minerase=2;
int maxerase=5;
int notime=240;

const color_t ccolor[]={WHITE,LIGHTGREEN,YELLOW,BROWN,LIGHTRED,LIGHTMAGENTA,MAGENTA,LIGHTBLUE,CYAN,LIGHTGRAY,WHITE};

int fontwidth;
int fontheight;
int font_title=60;
int font_normal=40;
int font_small=30;

const string cheat_name[maxcheat]={"wangzheng","wangziye","machengxin","xulei","gongyile","dutongru","wangguanlun","wangweineng","panyiyang","wanghuning","zhouchujie","sunmengxian","yuan0312","gixi","auki","sharlo","wind23"};

int erase=3;
int speed=3;
string lastname="guest";

int highscorecount=0;
string highscorestr[maxhighscore];
int highscorenum[maxhighscore];
int highscorelevel[maxhighscore];
int highscorecombine[maxhighscore];
bool nohighscore=false;
PIMAGE bg[4];
PIMAGE ball_ori;
PIMAGE ball;

int key;
mouse_msg mouse;
int cspeed;
bool cheat;

string player_name="";
string cheat_input="";

int bd[12][12];
int level=0;
int levelreal=0;
bool levelup=false;
int cballcount[11];
double totalscore=0;
double probabilty[11];

int cbd;
int cbdx[maxcbd];
int cbdy[maxcbd];
int cbdm[maxcbd];
int cbdxm[maxcbd];
int cbdym[maxcbd];

string str_font="Arial";
string str_title="Combine";
string menu_str_title="Combine - Menu";
string menu_str_pause="Pause";
string menu_str_play="Play";
string menu_str_highscore="HighScore";
string menu_str_option="Option";
string menu_str_exit="Exit";
string pause_str_title="Combine - Pause";
string pause_str_resume="Resume game";
string pause_str_return="Return menu";
string play_str_title="Combine - Play";
string play_str_name="Your name:";
string highscore_str_title="Combine - HighScore";
string option_str_title="Combine - Option";
string option_str_combine="Combine";
string option_str_width="Widht";
string option_str_height="Height";
string option_str_music="Music";
string option_str_sound="Sound";
string option_str_speed="Speed";

void changetitle(string str)
{
	setcaption(str.c_str());
}

void loadhighscore()
{
	highscore_file_in.open(highscore_file_name.c_str(),ios::in);
	highscore_file_in>>highscorecount;
	for(int count=1;count<=highscorecount;count++)
	{
		getline(highscore_file_in,highscorestr[count]);
		getline(highscore_file_in,highscorestr[count]);
		highscore_file_in>>highscorenum[count];
		highscore_file_in>>highscorelevel[count];
		highscore_file_in>>highscorecombine[count];
	}
	highscore_file_in.close();
}

void savehighscore()
{
	highscore_file_out.open(highscore_file_name.c_str(),ios::out);
	highscore_file_out<<highscorecount<<endl;
	for(int count=1;count<=highscorecount;count++)
	{
		highscore_file_out<<highscorestr[count]<<endl;
		highscore_file_out<<highscorenum[count]<<endl;
		highscore_file_out<<highscorelevel[count]<<endl;
		highscore_file_out<<highscorecombine[count]<<endl;
	}
	highscore_file_out.close();
}


void gethighscore()
{
	highscore_file_in.open(highscore_file_name.c_str(),ios::in);
	highscore_file_in.close();
	if(highscore_file_in.fail())
	{
		savehighscore();
	}
	else
	{
		loadhighscore();
	}
}

void loadsetting()
{
	setting_file_in.open(setting_file_name.c_str(),ios::in);
	getline(setting_file_in,lgsetting_file_name);
	getline(setting_file_in,lastname);
	setting_file_in>>erase;
	setting_file_in>>width;
	setting_file_in>>height;
	setting_file_in>>music;
	setting_file_in>>sound;
	setting_file_in>>speed;
	setting_file_in.close();
}

void savesetting()
{
	setting_file_out.open(setting_file_name.c_str(),ios::out);
	setting_file_out<<lgsetting_file_name<<endl;
	setting_file_out<<lastname<<endl;
	setting_file_out<<erase<<endl;
	setting_file_out<<width<<endl;
	setting_file_out<<height<<endl;
	setting_file_out<<music<<endl;
	setting_file_out<<sound<<endl;
	setting_file_out<<speed<<endl;
	setting_file_out.close();
}

void getsetting()
{
	setting_file_in.open(setting_file_name.c_str(),ios::in);
	setting_file_in.close();
	if(setting_file_in.fail())
	{
		savesetting();
	}
	else
	{
		loadsetting();
	}
}

void loadlgsetting()
{
	lgsetting_file_in.open(lgsetting_file_name.c_str(),ios::in);
	getline(lgsetting_file_in,str_font);
	getline(lgsetting_file_in,str_title);
	getline(lgsetting_file_in,menu_str_title);
	getline(lgsetting_file_in,menu_str_pause);
	getline(lgsetting_file_in,menu_str_play);
	getline(lgsetting_file_in,menu_str_highscore);
	getline(lgsetting_file_in,menu_str_option);
	getline(lgsetting_file_in,menu_str_exit);
	getline(lgsetting_file_in,pause_str_title);
	getline(lgsetting_file_in,pause_str_resume);
	getline(lgsetting_file_in,pause_str_return);
	getline(lgsetting_file_in,play_str_title);
	getline(lgsetting_file_in,play_str_name);
	getline(lgsetting_file_in,highscore_str_title);
	getline(lgsetting_file_in,option_str_title);
	getline(lgsetting_file_in,option_str_combine);
	getline(lgsetting_file_in,option_str_width);
	getline(lgsetting_file_in,option_str_height);
	getline(lgsetting_file_in,option_str_music);
	getline(lgsetting_file_in,option_str_sound);
	getline(lgsetting_file_in,option_str_speed);
	lgsetting_file_in.close();
}

void savelgsetting()
{
	lgsetting_file_out.open(lgsetting_file_name.c_str(),ios::out);
	lgsetting_file_out<<str_font<<endl;
	lgsetting_file_out<<str_title<<endl;
	lgsetting_file_out<<menu_str_title<<endl;
	lgsetting_file_out<<menu_str_pause<<endl;
	lgsetting_file_out<<menu_str_play<<endl;
	lgsetting_file_out<<menu_str_highscore<<endl;
	lgsetting_file_out<<menu_str_option<<endl;
	lgsetting_file_out<<menu_str_exit<<endl;
	lgsetting_file_out<<pause_str_title<<endl;
	lgsetting_file_out<<pause_str_resume<<endl;
	lgsetting_file_out<<pause_str_return<<endl;
	lgsetting_file_out<<play_str_title<<endl;
	lgsetting_file_out<<play_str_name<<endl;
	lgsetting_file_out<<highscore_str_title<<endl;
	lgsetting_file_out<<option_str_title<<endl;
	lgsetting_file_out<<option_str_combine<<endl;
	lgsetting_file_out<<option_str_width<<endl;
	lgsetting_file_out<<option_str_height<<endl;
	lgsetting_file_out<<option_str_music<<endl;
	lgsetting_file_out<<option_str_sound<<endl;
	lgsetting_file_out<<option_str_speed<<endl;
	lgsetting_file_out.close();
}

void getlgsetting()
{
	lgsetting_file_in.open(lgsetting_file_name.c_str(),ios::in);
	lgsetting_file_in.close();
	if(lgsetting_file_in.fail())
	{
		savelgsetting();
	}
	else
	{
		loadlgsetting();
	}
}

void initimage()
{
	bg[1]=newimage();
	getimage(bg[1],"image\\menu.bmp",0,0);
	bg[2]=newimage();
	getimage(bg[2],"image\\option.bmp",0,0);
	bg[3]=newimage();
	getimage(bg[3],"image\\play.bmp",0,0);
	ball_ori=newimage();
	getimage(ball_ori,"image\\ball.png",0,0);
	ball=newimage(width,int(height/10));
	putimage(ball,0,0,width,int(height/10),ball_ori,0,0,400,40);
}

void drawline()
{
	drawline(0.3,0.3,1,0.3,LIGHTRED);
}

void drawscore(int ilevel)
{
	if(!(cballcount[ilevel]==0))drawint(cballcount[ilevel],0.1,1-double(ilevel)/10,0.3,1-double(ilevel-1)/10,ccolor[ilevel]);
	drawint(totalscore,0.3,0,1,0.1,ccolor[levelreal-1]);
}

void setfontsize(int size)
{
	fontwidth=int(size*width/960);
	if(str_font=="Arial")
	{
		fontheight=int(size*height/400);
	}
	else
	{
		fontheight=int(size*height/500);
	}
	setfont(fontheight,0,str_font.c_str());
}

void resetgraph()
{
	closegraph();
	initgraph(width,height);
	changetitle(str_title);
	setfontsize(font_normal);
}

void showfps()
{
	setfontsize(font_small/2);
	drawint(getfps(),0.9,0,1,0.05,WHITE,BLACK);
	setfontsize(font_normal);
}

void waitmsg()
{
	while((!kbhit())&&(!mousemsg()))
	{
		delay_fps(notime);
		showfps();
	}
}

bool is_in(double x1,double y1,double x2,double y2)
{
	if((double(mouse.x)/width>x1)&&(double(mouse.y)/height>y1))
	{
		if((double(mouse.x)/width<x2)&&(double(mouse.y)/height<y2))
		{
			return true;
		}
	}
	return false;
}

void optioncheck()
{
	if(erase<minerase)erase=minerase;
	if(erase>maxerase)erase=maxerase;
	if(width<width_min)width=width_min;
	if(width>width_max)width=width_max;
	if(height<height_min)height=height_min;
	if(height>height_max)height=height_max;
	if(music<0)music=0;
	if(music>1)music=1;
	if(sound<0)sound=0;
	if(sound>1)sound=1;
	if(speed<1)speed=1;
	if(speed>maxspeed)speed=maxspeed;
	wsprintf(cmd,"setaudio bg volume to %i",(int)(music*1000));
	mciSendString(TEXT(cmd),NULL,0,0);
}

void optionswitch(int option_choose,int way)
{
	if(way==-1)
	{
		switch(option_choose)
		{
		case 1:erase-=1;break;
		case 2:width-=50;break;
		case 3:height-=50;break;
		case 4:music-=0.1;break;
		case 5:sound-=0.1;break;
		case 6:speed-=1;break;
		}
	}
	if(way==1)
	{
		switch(option_choose)
		{
		case 1:erase+=1;break;
		case 2:width+=50;break;
		case 3:height+=50;break;
		case 4:music+=0.1;break;
		case 5:sound+=0.1;break;
		case 6:speed+=1;break;
		}
	}
}

void option()
{
	int option_choose=1;
	int option_choose_new=1;
	bool option_over=false;
	int width_old;
	int height_old;
	while (!option_over)
	{
		str_title=option_str_title;
		changetitle(str_title);
		width_old=width;
		height_old=height;
		drawimage(bg[2],0,0,0,0,400,400);
		setfontsize(font_title);
		drawstr(menu_str_option,0.5,0.15,color_title);
		setfontsize(font_normal);
		drawstr(option_str_combine,0.25,0.35);drawint(erase,0.75,0.35);
		drawstr(option_str_width,0.25,0.45);drawint(width,0.75,0.45);
		drawstr(option_str_height,0.25,0.55);drawint(height,0.75,0.55);
		drawstr(option_str_music,0.25,0.65);drawint(music*10,0.75,0.65);
		drawstr(option_str_sound,0.25,0.75);drawint(sound*10,0.75,0.75);
		drawstr(option_str_speed,0.25,0.85);drawint(speed,0.75,0.85);
		switch(option_choose)
		{
		case 1:drawstr(option_str_combine,0.25,0.35,color_choosed);drawint(erase,0.75,0.35,color_choosed);break;
		case 2:drawstr(option_str_width,0.25,0.45,color_choosed);drawint(width,0.75,0.45,color_choosed);break;
		case 3:drawstr(option_str_height,0.25,0.55,color_choosed);drawint(height,0.75,0.55,color_choosed);break;
		case 4:drawstr(option_str_music,0.25,0.65,color_choosed);drawint(music*10,0.75,0.65,color_choosed);break;
		case 5:drawstr(option_str_sound,0.25,0.75,color_choosed);drawint(sound*10,0.75,0.75,color_choosed);break;
		case 6:drawstr(option_str_speed,0.25,0.85,color_choosed);drawint(speed,0.75,0.85,color_choosed);break;
		}
		waitmsg();
		if(kbhit())
		{
			key=getch();
			if(key==293)optionswitch(option_choose,-1);
			if(key==295)optionswitch(option_choose,1);
			optioncheck();
			if(key==294)option_choose--;
			if(key==296)option_choose++;
			if(option_choose<1)option_choose=1;
			if(option_choose>6)option_choose=6;
			if(key==9)option_choose++;
			if(option_choose>6)option_choose=1;
			if(key==32)key=13;
			if(key==8)key=27;
			if(key==13)key=27;
			if(key==27)option_over=true;
			switch(key)
			{
			case 293:makesound("sound\\levelup.mp3");break;
			case 294:makesound("sound\\down.mp3");break;
			case 295:makesound("sound\\levelup.mp3");break;
			case 296:makesound("sound\\down.mp3");break;
			case 9:makesound("sound\\down.mp3");break;
			case 27:makesound("sound\\create.mp3");break;
			}
		}
		else
		{
			mouse=getmouse();
			if(is_in(0,0.3,1,0.4))option_choose_new=1;
			if(is_in(0,0.4,1,0.5))option_choose_new=2;
			if(is_in(0,0.5,1,0.6))option_choose_new=3;
			if(is_in(0,0.6,1,0.7))option_choose_new=4;
			if(is_in(0,0.7,1,0.8))option_choose_new=5;
			if(is_in(0,0.8,1,0.9))option_choose_new=6;
			if(!(option_choose_new==option_choose))
			{
				option_choose=option_choose_new;
				makesound("sound\\down.mp3");
			}
			if(mouse.is_wheel())
			{
				if(mouse.wheel<0)optionswitch(option_choose,1);
				if(mouse.wheel>0)optionswitch(option_choose,-1);
				optioncheck();
			}//wheel
			if(mouse.is_down())
			{
				if(is_in(0,0.3,1,0.9))
				{
					if(mouse.is_left())optionswitch(option_choose,1);
					if(mouse.is_right())optionswitch(option_choose,-1);
					optioncheck();
				}
				else
				{
					option_over=true;
					makesound("sound\\create.mp3");
				}
			}//isdown
		}//mouse
		if(!((width==width_old)&&(height==height_old)))resetgraph();
	}
	savesetting();
	initimage();
}

void sorthighscore()
{
	bool nochange=false;
	while(!nochange)
	{
		nochange=true;
		for(int hsort=1;hsort<=highscorecount-1;hsort++)
		{
			if(highscorenum[hsort]<highscorenum[hsort+1])
			{
				nochange=false;
				highscorestr[0]=highscorestr[hsort];
				highscorestr[hsort]=highscorestr[hsort+1];
				highscorestr[hsort+1]=highscorestr[0];
				highscorenum[0]=highscorenum[hsort];
				highscorenum[hsort]=highscorenum[hsort+1];
				highscorenum[hsort+1]=highscorenum[0];
				highscorelevel[0]=highscorelevel[hsort];
				highscorelevel[hsort]=highscorelevel[hsort+1];
				highscorelevel[hsort+1]=highscorelevel[0];
				highscorecombine[0]=highscorecombine[hsort];
				highscorecombine[hsort]=highscorecombine[hsort+1];
				highscorecombine[hsort+1]=highscorecombine[0];
			}
		}
	}
}

void addhighscore(string str)
{
	highscorecount++;
	highscorestr[highscorecount]=str;
	highscorenum[highscorecount]=totalscore;
	highscorelevel[highscorecount]=levelreal;
	highscorecombine[highscorecount]=erase;
}

void highscore()
{
	sorthighscore();
	int highscore_choose=1;
	bool highscore_over=false;
	int hmin=1;
	int hmax=highscorecount;
	if(hmax>9)hmax=9;
	while (!highscore_over)
	{
		str_title=highscore_str_title;
		changetitle(str_title);
		drawimage(bg[2],0,0,0,0,400,400);
		setfontsize(font_title);
		drawstr(menu_str_highscore,0.5,0.15,color_title);
		setfontsize(font_normal);
		setfontsize(font_small);
		for(int hcount=hmin;hcount<=hmax;hcount++)
		{
			double hheight=double(hcount+4-hmin)/13;
			drawint(hcount,0.05,hheight,ccolor[highscorelevel[hcount]-1]);
			drawint(highscorecombine[hcount],0.15,hheight,ccolor[highscorelevel[hcount]-1]);
			drawstr(highscorestr[hcount],0.5,hheight,ccolor[highscorelevel[hcount]-1]);
			drawint(highscorenum[hcount],0.85,hheight,ccolor[highscorelevel[hcount]-1]);
		}
		setfontsize(font_normal);
		waitmsg();
		if(kbhit())
		{
			key=getch();
			if(key==293)key=294;
			if(key==295)key=296;
			if(key==294){hmin--;hmax--;}
			if(key==296){hmin++;hmax++;}
			if(hmin<1){hmin++;hmax++;}
			if(hmax>highscorecount){hmax--;hmin--;}
			if(key==9){hmin++;hmax++;}
			if(hmax>highscorecount)while(!(hmin==1)){hmin--;hmax--;}
			if(key==32)key=27;
			if(key==8)key=27;
			if(key==13)key=27;
			if(key==27)highscore_over=true;
			switch(key)
			{
			case 294:makesound("sound\\down.mp3");break;
			case 296:makesound("sound\\down.mp3");break;
			case 9:makesound("sound\\down.mp3");break;
			case 27:makesound("sound\\create.mp3");break;
			}
		}
		else
		{
			mouse=getmouse();
			if(mouse.is_down())
			{
				highscore_over=true;
				makesound("sound\\create.mp3");
			}
			if(mouse.is_wheel())
			{
				if(mouse.wheel<0)
				{
					hmin++;hmax++;
					if(hmax>highscorecount){hmin--;hmax--;}
					makesound("sound\\down.mp3");
				}
				if(mouse.wheel>0)
				{
					hmin--;hmax--;
					if(hmin<1){hmin++;hmax++;}
					makesound("sound\\down.mp3");
				}
			}//wheel
		}//mouse
	}
}

bool isdead()
{
	bool dead=false;
	for(int deadcount=4;deadcount<=10;deadcount++)
	{
		if(!bd[deadcount][2]==0)dead=true;
		if(!bd[deadcount][3]==0)dead=true;
	}
	return dead;
}

void drawball(int num,int x,int y)
{
	if(!num==0)drawimagetransparent(ball,double(x-1)/10,double(y-1)/10,(num-1)*int(width/10),0,int(width/10),int(height/10));
}

void clearball(int x,int y)
{
	drawimage(bg[3],double(x-1)/10,double(y-1)/10,int((x-1)*40),int((y-1)*40),40,40);
}

void addball(int num,int x,int y)
{
	bd[x][y]=num;
	drawball(num,x,y);
}

void delball(int x,int y)
{
	bd[x][y]=0;
	clearball(x,y);
}

void moveball(int dx,int dy,int sx,int sy)
{
	addball(bd[sx][sy],dx,dy);
	delball(sx,sy);
}

int setprobabilty()
{
	int rndmax=0;
	for(int rndcount=1;rndcount<=level;rndcount++)
	{
		if(rndcount<(level+0.5)/2)
		{
			probabilty[rndcount]=rndcount;
			rndmax+=probabilty[rndcount];
		}
		else
		{
			probabilty[rndcount]=(level-rndcount+1);
			rndmax+=probabilty[rndcount];
		}
	}
	return rndmax;
}

int randomball()
{
	setprobabilty();
	int rndnum=random(setprobabilty());
	int rndcount=0;
	while(rndnum>=0)
	{
		rndcount++;
		if(rndcount<(level+0.5)/2)
		{
			rndnum-=rndcount;
		}
		else
		{
			rndnum-=(level-rndcount+1);
		}
	}
	return rndcount;
}

void newball()
{
	int r1=randomball();
	int r2=randomball();
	if(cheat)r2=r1;
	addball(r1,6,3);
	addball(r2,7,3);
}

void redrawgraph()
{
	initimage();
	drawimage(bg[3],0,0,0,0,400,400);
	bar(0,0,int(3*width/10),height);
	for(int rx=0;rx<=10;rx++)
	{
		for(int ry=0;ry<=10;ry++)
		{
			drawball(bd[rx][ry],rx,ry);
		}
	}
	for(int r=1;r<=level;r++)
	{
		drawscore(r);
	}
	drawline();
}

void pausecheck()
{
	if(width<width_min)width=width_min;
	if(width>width_max)width=width_max;
	if(height<height_min)height=height_min;
	if(height>height_max)height=height_max;
	if(music<0)music=0;
	if(music>1)music=1;
	if(sound<0)sound=0;
	if(sound>1)sound=1;
	if(speed<1)speed=1;
	if(speed>maxspeed)speed=maxspeed;
	wsprintf(cmd,"setaudio bg volume to %i",(int)(music*1000));
	mciSendString(TEXT(cmd),NULL,0,0);
	makesound("sound\\levelup.mp3");
}

void pauseswitch(int pause_choose,int way)
{
	if(way==-1)
	{
		switch(pause_choose)
		{
		case 3:width-=50;break;
		case 4:height-=50;break;
		case 5:music-=0.1;break;
		case 6:sound-=0.1;break;
		case 7:speed-=1;break;
		}
	}
	if(way==1)
	{
		switch(pause_choose)
		{
		case 3:width+=50;break;
		case 4:height+=50;break;
		case 5:music+=0.1;break;
		case 6:sound+=0.1;break;
		case 7:speed+=1;break;
		}
	}
}

bool pause()
{
	bool pause_back=false;
	makesound("sound\\clear.mp3");
	int pause_choose=1;
	int pause_choose_new=1;
	bool pause_over=false;
	int width_old;
	int height_old;
	while (!pause_over)
	{
		str_title=pause_str_title;
		changetitle(str_title);
		width_old=width;
		height_old=height;
		drawimage(bg[2],0,0,0,0,400,400);
		setfontsize(font_title);
		drawstr(menu_str_pause,0.5,0.15,color_title);
		setfontsize(font_normal);
		drawstr(pause_str_resume,0.5,0.3);
		drawstr(pause_str_return,0.5,0.4);
		drawstr(option_str_width,0.25,0.5);drawint(width,0.75,0.5);
		drawstr(option_str_height,0.25,0.6);drawint(height,0.75,0.6);
		drawstr(option_str_music,0.25,0.7);drawint(music*10,0.75,0.7);
		drawstr(option_str_sound,0.25,0.8);drawint(sound*10,0.75,0.8);
		drawstr(option_str_speed,0.25,0.9);drawint(speed,0.75,0.9);
		switch(pause_choose)
		{
		case 1:drawstr(pause_str_resume,0.5,0.3,color_choosed);break;
		case 2:drawstr(pause_str_return,0.5,0.4,color_choosed);break;
		case 3:drawstr(option_str_width,0.25,0.5,LIGHTRED);drawint(width,0.75,0.5,color_choosed);break;
		case 4:drawstr(option_str_height,0.25,0.6,color_choosed);drawint(height,0.75,0.6,color_choosed);break;
		case 5:drawstr(option_str_music,0.25,0.7,color_choosed);drawint(music*10,0.75,0.7,color_choosed);break;
		case 6:drawstr(option_str_sound,0.25,0.8,color_choosed);drawint(sound*10,0.75,0.8,color_choosed);break;
		case 7:drawstr(option_str_speed,0.25,0.9,color_choosed);drawint(speed,0.75,0.9,color_choosed);break;
		}
		waitmsg();
		if(kbhit())
		{
			key=getch();
			if(key==293)pauseswitch(pause_choose,-1);
			if(key==295)pauseswitch(pause_choose,1);
			pausecheck();
			if(key==294)pause_choose--;
			if(key==296)pause_choose++;
			if(pause_choose<1)pause_choose=1;
			if(pause_choose>7)pause_choose=7;
			if(key==9)pause_choose++;
			if(pause_choose>7)pause_choose=1;
			if(key==32)key=13;
			if(key==8)key=27;
			if(key==27)pause_over=true;
			switch(key)
			{
			case 293:makesound("sound\\levelup.mp3");break;
			case 294:makesound("sound\\down.mp3");break;
			case 295:makesound("sound\\levelup.mp3");break;
			case 296:makesound("sound\\down.mp3");break;
			case 9:makesound("sound\\down.mp3");break;
			case 27:makesound("sound\\create.mp3");break;
			case 13:
				{
					makesound("sound\\create.mp3");
					pause_over=true;
					if(pause_choose==2)pause_back=true;
					break;
				}
			}//switch
		}//kbhit
		else
		{
			mouse=getmouse();
			if(is_in(0,0.25,1,0.35))pause_choose_new=1;
			if(is_in(0,0.35,1,0.45))pause_choose_new=2;
			if(is_in(0,0.45,1,0.55))pause_choose_new=3;
			if(is_in(0,0.55,1,0.65))pause_choose_new=4;
			if(is_in(0,0.65,1,0.75))pause_choose_new=5;
			if(is_in(0,0.75,1,0.85))pause_choose_new=6;
			if(is_in(0,0.85,1,0.95))pause_choose_new=7;
			if(!(pause_choose_new==pause_choose))
			{
				pause_choose=pause_choose_new;
				makesound("sound\\down.mp3");
			}
			if((mouse.is_wheel())&&(pause_choose>=3))
			{
				if(mouse.wheel<0)pauseswitch(pause_choose,1);
				if(mouse.wheel>0)pauseswitch(pause_choose,-1);
				pausecheck();
			}//wheel
			if(mouse.is_down())
			{
				if(is_in(0,0.45,1,1.0))
				{
					if(mouse.is_left())pauseswitch(pause_choose,1);
					if(mouse.is_right())pauseswitch(pause_choose,-1);
					pausecheck();
				}
				else
				{
					pause_over=true;
					makesound("sound\\create.mp3");
					if((pause_choose==2)&&(mouse.is_left()))pause_back=true;
				}
			}//isdown
		}//mouse
		if(!((width==width_old)&&(height==height_old)))resetgraph();
	}
	savesetting();
	redrawgraph();
	return pause_back;
}

void leftball()
{
	int leftcount=4;
	while(bd[leftcount][3]==0)leftcount++;
	if(leftcount>4)
	{
		moveball(leftcount-1,2,leftcount,2);
		moveball(leftcount-1,3,leftcount,3);
		if(!(bd[leftcount+1][3]==0))moveball(leftcount,3,leftcount+1,3);
	}
}

void rightball()
{
	int rightcount=10;
	while(bd[rightcount][3]==0)rightcount--;
	if(rightcount<10)
	{
		moveball(rightcount+1,2,rightcount,2);
		moveball(rightcount+1,3,rightcount,3);
		if(!(bd[rightcount-1][3]==0))moveball(rightcount,3,rightcount-1,3);
	}
}

void upball()
{
	int upcount=4;
	while(bd[upcount][3]==0)upcount++;
	if(bd[upcount][2]==0)
	{
		moveball(upcount+1,2,upcount,3);
		if(upcount==4)leftball();
	}
	else
	{
		if(upcount==4)
		{
			moveball(upcount+1,3,upcount,2);
		}
		else
		{
			moveball(upcount-1,3,upcount,3);
			moveball(upcount,3,upcount,2);
		}
	}
}

void downball()
{
	bool down_over=false;
	bool have_down=false;
	while(!down_over)
	{
		down_over=true;
		for(int downwidth=4;downwidth<=10;downwidth++)
		{
			for(int downheight=10;downheight>=3;downheight--)
			{
				if((bd[downwidth][downheight]==0)&&(!(bd[downwidth][downheight-1]==0)))
				{
					down_over=false;
					have_down=true;
					moveball(downwidth,downheight,downwidth,downheight-1);
				}
			}
		}
		drawline();
		delay_fps(speed*15);
	}
	if(have_down)makesound("sound\\down.mp3");
}

bool combineball()
{
	int cpos=0;
	int ccount=0;
	int cwidthnow=0;
	int cheightnow=0;
	int cwidthmax=0;
	int cheightmax=0;
	int cmore=0;
	bool ccombine=false;
	for(int cwidth=4;cwidth<=10;cwidth++)
	{
		for(int cheight=2;cheight<=10;cheight++)
		{
			if(!(bd[cwidth][cheight]==0))
			{
				cbd=bd[cwidth][cheight];
				cbdx[0]=cwidth;
				cbdy[0]=cheight;
				cpos=0;
				ccount=0;
				bd[cbdx[ccount]][cbdy[ccount]]+=100;
				while(cpos<=ccount)
				{
					cwidthnow=cbdx[cpos];
					cheightnow=cbdy[cpos];
					if(bd[cwidthnow+1][cheightnow]==cbd)
					{
						ccount++;
						cbdx[ccount]=cwidthnow+1;
						cbdy[ccount]=cheightnow;
						bd[cbdx[ccount]][cbdy[ccount]]+=100;
					}
					if(bd[cwidthnow][cheightnow+1]==cbd)
					{
						ccount++;
						cbdx[ccount]=cwidthnow;
						cbdy[ccount]=cheightnow+1;
						bd[cbdx[ccount]][cbdy[ccount]]+=100;
					}
					if(bd[cwidthnow-1][cheightnow]==cbd)
					{
						ccount++;
						cbdx[ccount]=cwidthnow-1;
						cbdy[ccount]=cheightnow;
						bd[cbdx[ccount]][cbdy[ccount]]+=100;
					}
					if(bd[cwidthnow][cheightnow-1]==cbd)
					{
						ccount++;
						cbdx[ccount]=cwidthnow;
						cbdy[ccount]=cheightnow-1;
						bd[cbdx[ccount]][cbdy[ccount]]+=100;
					}
					cpos++;
				}//while cpos<ccount
				for(cpos=0;cpos<=ccount;cpos++)
				{
					bd[cbdx[cpos]][cbdy[cpos]]-=100;
				}
				if(ccount>=(erase-1))
				{
					cheightmax=0;
					cwidthmax=11;
					for(cpos=0;cpos<=ccount;cpos++)
					{
						delball(cbdx[cpos],cbdy[cpos]);
						drawint(cbd,double(cbdx[cpos]-0.5)/10,double(cbdy[cpos]-0.5)/10,ccolor[cbd]);
						setprobabilty();
						totalscore+=1/double(probabilty[cbd])*int((levelreal+1)/2)*12*erase;
						if(cheightmax<cbdy[cpos])
						{
							cheightmax=cbdy[cpos];
							cwidthmax=cbdx[cpos];
						}
						if(cheightmax==cbdy[cpos])
						{
							if(cwidthmax>cbdx[cpos])
							{
								cheightmax=cbdy[cpos];
								cwidthmax=cbdx[cpos];
							}
						}
					}
					cballcount[cbd]+=(ccount+1);
					drawscore(cbd);
					cmore++;
					cbdxm[cmore]=cwidthmax;
					cbdym[cmore]=cheightmax;
					cbdm[cmore]=cbd+1;
					if(level<cbd+1)
					{
						level++;
						levelreal++;
						levelup=true;
						if(level>10)level--;
						if(levelreal>11)levelreal--;
					}
				}//if ccount>2
			}//if bd==0
		}//for height
	}//for width
	if(cmore>0)ccombine=true;
	if(ccombine)
	{
		delay_fps(speed+cspeed);
		makesound("sound\\clear.mp3");
		for(int cwidth=4;cwidth<=10;cwidth++)
		{
			for(int cheight=2;cheight<=10;cheight++)
			{
				if(bd[cwidth][cheight]==0)
				{
					delball(cwidth,cheight);
					if(cheight==3)drawline();
				}
			}
		}
		delay_fps(speed);
		makesound("sound\\create.mp3");
		if(levelup)
		{
			makesound("sound\\levelup.mp3");
			levelup=false;
			addball(level,1,10-level+1);
			drawscore(level);
		}//if levelup
		for(int cmorecount=1;cmorecount<=cmore;cmorecount++)
		{
			if(cbdm[cmorecount]<=10)
			{
				addball(cbdm[cmorecount],cbdxm[cmorecount],cbdym[cmorecount]);
			}
		}
	}//if combine
	cspeed=0;
	return ccombine;
}

void playball()
{
	bool have_combine=true;
	cspeed=notime;
	while(have_combine)
	{
		downball();
		have_combine=combineball();
	}
}

void checkcheat()
{
	if((key>=48)&&(key<=126)&&(player_name.length()<24))
	{
		cheat_input+=char(key);
	}
	else
	{
		cheat_input="";
	}
	for(int cheatcount=0;cheatcount<=maxcheat-1;cheatcount++)
	{
		if((cheat_input==cheat_name[cheatcount])&&(!cheat))
		{
			cheat=true;
			maxerase=50;
			minerase=1;
			makesound("sound\\gameover.mp3");
			for(int cheatrepeat=1;cheatrepeat<=5;cheatrepeat++)
			{
				for(int cheatcolor=1;cheatcolor<=10;cheatcolor++)
				{
					delay_fps(20);
					drawstr("ɰ",0.4,0.4,0.9,0.5,ccolor[cheatcolor]);
					drawstr(cheat_input,0.4,0.5,0.9,0.6,ccolor[cheatcolor]);
				}
			}
			drawstr("ɰ",0.4,0.4,0.9,0.5,ccolor[levelreal-1]);
			drawstr(cheat_input,0.4,0.5,0.9,0.6,ccolor[levelreal-1]);
		}
	}
}

void play()
{
	int play_choose=1;
	bool play_over=false;
	bool play_drop=false;
//	int leftcount;
	int rightcount;
	int ball_new;
	drawimage(bg[3],0,0,0,0,400,400);
	level=1;
	levelreal=1;
	totalscore=0;
	for(int pc=1;pc<=10;pc++)
	{
		cballcount[pc]=0;
	}
	for(int px=1;px<=10;px++)
	{
		for(int py=1;py<=10;py++)
		{
			bd[px][py]=0;
		}
	}
	bar(0,0,int(3*width/10),height);
	drawscore(level);
	for(int levelcount=1;levelcount<=level;levelcount++)
	{
		addball(levelcount,1,10-levelcount+1);
	}
	while(!play_over)
	{
		str_title=play_str_title;
		changetitle(str_title);
		drawline();
		if(level<=8)
		{
			makemusic("sound\\bg1.mp3");
		}
		else
		{
			makemusic("sound\\bg2.mp3");
		}
		play_over=isdead();
		if(!play_over)
		{
			newball();
			play_drop=false;
			while(!play_drop)
			{
				waitmsg();
				if(kbhit())
				{
					key=getch();
					if(key==8)key=27;
					if(key==9)key=294;
					if(key==32)key=296;
					if(key==13)key=296;
					switch(key)
					{
					case 293:leftball();break;
					case 295:rightball();break;
					case 294:upball();break;
					case 296:play_drop=true;break;
					case 27:play_over=pause();break;
					}
					checkcheat();
				}
				else
				{
					mouse=getmouse();
					if(mouse.is_wheel())
					{
						upball();
					}
					if(mouse.is_down())
					{
						if(is_in(0.3,0.1,1.0,1))
						{
							if(mouse.is_left())play_drop=true;
							if(mouse.is_right())upball();
						}
						else
						{
							play_over=pause();
						}
					}
					if(is_in(0.3,0.1,0.4,1))ball_new=4;
					if(is_in(0.4,0.1,0.5,1))ball_new=5;
					if(is_in(0.5,0.1,0.6,1))ball_new=6;
					if(is_in(0.6,0.1,0.7,1))ball_new=7;
					if(is_in(0.7,0.1,0.8,1))ball_new=8;
					if(is_in(0.8,0.1,0.9,1))ball_new=9;
					if(is_in(0.9,0.1,1.0,1))ball_new=10;
//					leftcount=4;
//					while(bd[leftcount][3]==0)leftcount++;
					rightcount=10;
					while(bd[rightcount][3]==0)rightcount--;
					if(rightcount>ball_new)leftball();
					if(rightcount<ball_new)rightball();
				}
				if(play_over)play_drop=true;
			}//while drop
			if(!play_over)playball();
		}//if dead
	}//while over
	makesound("sound\\gameover.mp3");
	delay_fps(speed/2);
	makemusic("sound\\bg3.mp3");
	bool name_over=false;
	nohighscore=false;
	if((!cheat)&&(erase>=2)&&(erase<=5))
	{
		player_name=lastname;
		while(!name_over)
		{
			drawstr(play_str_name,0.4,0.4,0.9,0.5);
			setfontsize(font_small);
			drawstr(player_name,0.4,0.5,0.9,0.6,ccolor[levelreal-1]);
			setfontsize(font_normal);
			waitmsg();
			if(kbhit())
			{
				key=getch();
				if((key>=32)&&(key<=126)&&(player_name.length()<24))player_name+=char(key);
				if(key==8)player_name=player_name.substr(0,player_name.length()-1);
				if((key==27)&&(player_name=="")){name_over=true;nohighscore=true;}
				if(key==27)player_name="";
				if(key==13)name_over=true;
			}
			else
			{
				mouse=getmouse();
				if(mouse.is_down())
				{
					if(mouse.is_left())key=13;
					if(mouse.is_right())key=27;
					if((key==27)&&(player_name=="")){name_over=true;nohighscore=true;}
					if(key==27)player_name="";
					if(key==13)name_over=true;
				}
			}//kbhit
		}//name_over
		if(!nohighscore)
		{
			lastname=player_name;
			addhighscore(player_name);
			savehighscore();
			savesetting();
			highscore();
		}
	}
	cheat=false;
}

bool menuswitch(int menu_choose)
{
	switch(menu_choose)
	{
	case 1:makesound("sound\\levelup.mp3");play();break;
	case 2:makesound("sound\\clear.mp3");highscore();break;
	case 3:makesound("sound\\clear.mp3");option();break;
	case 4:makesound("sound\\gameover.mp3","wait");return true;break;
	}
	return false;
}

void menu()
{
	int menu_choose=1;
	int menu_choose_new=1;
	bool menu_over=false;
	bool firstmenu=true;
	while(!menu_over)
	{
		str_title=menu_str_title;
		changetitle(str_title);
		if(firstmenu)
		{
			makemusic("sound\\bg2.mp3");
			firstmenu=false;
		}
		drawimage(bg[1],0,0,0,0,400,400);
		drawstr(menu_str_play,0.5,0.6);
		drawstr(menu_str_highscore,0.5,0.7);
		drawstr(menu_str_option,0.5,0.8);
		drawstr(menu_str_exit,0.5,0.9);
		switch(menu_choose)
		{
		case 1:drawstr(menu_str_play,0.5,0.6,color_choosed);break;
		case 2:drawstr(menu_str_highscore,0.5,0.7,color_choosed);break;
		case 3:drawstr(menu_str_option,0.5,0.8,color_choosed);break;
		case 4:drawstr(menu_str_exit,0.5,0.9,color_choosed);break;
		}
		waitmsg();
		if(kbhit())
		{
			key=getch();
			if(key==293)key=294;
			if(key==295)key=296;
			if(key==294)menu_choose--;
			if(key==296)menu_choose++;
			if(menu_choose<1)menu_choose=1;
			if(menu_choose>4)menu_choose=4;
			if(key==9)menu_choose++;
			if(menu_choose>4)menu_choose=1;
			if(key==32)key=13;
			if(key==27)menu_over=true;
			switch(key)
			{
			case 293:makesound("sound\\down.mp3");break;
			case 294:makesound("sound\\down.mp3");break;
			case 295:makesound("sound\\down.mp3");break;
			case 296:makesound("sound\\down.mp3");break;
			case 9:makesound("sound\\down.mp3");break;
			case 13:menu_over=menuswitch(menu_choose);
			}//switch key
		}//kbhit
		else
		{
			mouse=getmouse();
			if(is_in(0.25,0.55,0.75,0.65))menu_choose_new=1;
			if(is_in(0.25,0.65,0.75,0.75))menu_choose_new=2;
			if(is_in(0.25,0.75,0.75,0.85))menu_choose_new=3;
			if(is_in(0.25,0.85,0.75,0.95))menu_choose_new=4;
			if(!(menu_choose_new==menu_choose))
			{
				menu_choose=menu_choose_new;
				makesound("sound\\down.mp3");
			}
			if(mouse.is_left()&&mouse.is_down()&&is_in(0.25,0.55,0.75,0.95))menu_over=menuswitch(menu_choose);
		}//mousemsg
	}//while !over
}

void initial()
{
	randomize();
	getsetting();
	getlgsetting();
	gethighscore();
	initgraph(width,height);
	initimage();
	resetgraph();
	setbkcolor(color_background);
	setcolor(color_front);
	setfillcolor(color_fill);
	setbkmode(color_mode);
}

int main()
{
	initial();
	menu();
	closegraph();
	return 0;
}