// combine.h

#ifndef _COMBINE_H_
#define _COMBINE_H_

#include <fstream>
#include <sstream>
#include <string>
#include <graphics.h>
#include <mmsystem.h>

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

extern ifstream setting_file_in;
extern ofstream setting_file_out;
extern ifstream lgsetting_file_in;
extern ofstream lgsetting_file_out;
extern ifstream highscore_file_in;
extern ofstream highscore_file_out;

extern string setting_file_name;
extern string lgsetting_file_name;
extern string highscore_file_name;

extern const int maxcbd;
extern const int maxhighscore;
extern const int maxcheat;

extern const color_t ccolor[];

extern int fontwidth;
extern int fontheight;
extern int font_title;
extern int font_normal;
extern int font_small;

extern const string cheat_name[maxcheat];

extern int erase;
extern int speed;
extern string lastname;

extern int highscorecount;
extern string highscorestr[maxhighscore];
extern int highscorenum[maxhighscore];
extern int highscorelevel[maxhighscore];
extern int highscorecombine[maxhighscore];
extern bool nohighscore;
extern PIMAGE bg[4];
extern PIMAGE ball_ori;
extern PIMAGE ball;

extern int key;
extern int cspeed;
extern bool cheat;

extern string player_name;
extern string cheat_input;

extern int bd[12][12];
extern int level;
extern int levelreal;
extern bool levelup;
extern int cballcount[11];
extern double totalscore;
extern double probabilty[11];

extern int cbd;
extern int cbdx[maxcbd];
extern int cbdy[maxcbd];
extern int cbdm[maxcbd];
extern int cbdxm[maxcbd];
extern int cbdym[maxcbd];

extern string str_font;
extern string str_title;
extern string menu_str_title;
extern string menu_str_pause;
extern string menu_str_play;
extern string menu_str_highscore;
extern string menu_str_option;
extern string menu_str_exit;
extern string pause_str_title;
extern string pause_str_resume;
extern string pause_str_return;
extern string play_str_title;
extern string play_str_name;
extern string highscore_str_title;
extern string option_str_title;
extern string option_str_combine;
extern string option_str_width;
extern string option_str_height;
extern string option_str_music;
extern string option_str_sound;
extern string option_str_speed;

extern void changetitle(string str);
extern void loadhighscore();
extern void savehighscore();
extern void gethighscore();
extern void loadsetting();
extern void savesetting();
extern void getsetting();
extern void loadlgsetting();
extern void savelgsetting();
extern void getlgsetting();
extern void initimage();
extern void drawline();
extern void drawscore(int ilevel);
extern void setfontsize(int size);
extern void resetgraph();
extern void option();
extern void sorthighscore();
extern void addhighscore(string str);
extern void highscore();
extern bool isdead();
extern void addball(int num,int x,int y);
extern void delball(int x,int y);
extern void moveball(int dx,int dy,int sx,int sy);
extern int randomball();
extern void newball();
extern bool pause();
extern void leftball();
extern void rightball();
extern void upball();
extern void downball();
extern bool combineball();
extern void playball();
extern void play();
extern void menu();
extern void initial();

#ifdef __cplusplus
}
#endif // __cplusplus

#endif // _COMBINE_H_

