// display.cpp

#include <graphics.h>
#include <sstream>
#include <string>

using namespace std;

color_t color_title=LIGHTBLUE;
color_t color_choosed=LIGHTRED;
color_t color_normal=YELLOW;
color_t color_background=WHITE;
color_t color_front=BLACK;
color_t color_fill=BLACK;
color_t color_mode=TRANSPARENT;

int width_min=150;
int height_min=150;
int width_max=1200;
int height_max=1200;
int width_default=400;
int height_default=400;

int width=400;
int height=400;

void drawtext(LPCSTR text,double x,double y,color_t color=color_normal)
{
	setcolor(color);
	double posx;
	double posy;
	posx=x*width;
	posy=y*height;
	posx-=textwidth(text)/2;
	posy-=textheight(text)/2;
	outtextxy(posx,posy,text);
}

void drawtext(LPCSTR text,double x1,double y1,double x2,double y2,color_t color=color_normal,color_t bgcolor=color_fill)
{
	if(!bgcolor==TRANSPARENT)
	{
		setfillcolor(bgcolor);
		bar(int(width*x1),int(height*y1),int(width*x2),int(height*y2));
	}
	drawtext(text,(x1+x2)/2,(y1+y2)/2,color);
}

void drawstr(string str,double x,double y,color_t color=color_normal)
{
	drawtext(str.c_str(),x,y,color);
}

void drawstr(string str,double x1,double y1,double x2,double y2,color_t color=color_normal,color_t bgcolor=color_fill)
{
	drawtext(str.c_str(),x1,y1,x2,y2,color,bgcolor);
}

void drawint(int i,double x,double y,color_t color=color_normal)
{
	stringstream ss;
	string str;
	ss<<i;
	ss>>str;
	drawstr(str,x,y,color);
}

void drawint(int i,double x1,double y1,double x2,double y2,color_t color=color_normal,color_t bgcolor=color_fill)
{
	stringstream ss;
	string str;
	ss<<i;
	ss>>str;
	drawstr(str,x1,y1,x2,y2,color,bgcolor);
}

void drawdouble(double d,double x,double y,color_t color=color_normal)
{
	stringstream ss;
	string str;
	ss<<d;
	ss>>str;
	drawstr(str,x,y,color);
}

void drawdouble(double d,double x1,double y1,double x2,double y2,color_t color=color_normal,color_t bgcolor=color_fill)
{
	stringstream ss;
	string str;
	ss<<d;
	ss>>str;
	drawstr(str,x1,y1,x2,y2,color,bgcolor);
}

void drawimage(PIMAGE img,double x,double y,int ix1,int iy1,int ix2,int iy2)
{
	putimage(x*width,y*height,int(x+ix2*width/width_default),int(y+iy2*height/height_default),img,ix1,iy1,ix2,iy2);
}

void drawimagetransparent(PIMAGE img,double x,double y,int ix1,int iy1,int ix2,int iy2)
{
	putimage_transparent(NULL,img,x*width,y*height,BLACK,ix1,iy1,ix2,iy2);	
}

void drawline(double x1,double y1,double x2,double y2,color_t color=color_front)
{
	setcolor(color);
	line(x1*width,y1*height,x2*width,y2*height);
}

