// display.h

#ifndef _DISPLAY_H_
#define _DISPLAY_H_

#include <graphics.h>
#include <string>

extern color_t color_title;
extern color_t color_choosed;
extern color_t color_normal;
extern color_t color_background;
extern color_t color_front;
extern color_t color_fill;
extern color_t color_mode;
extern int width_min;
extern int height_min;
extern int width_max;
extern int height_max;
extern int width_default;
extern int height_default;
extern int width;
extern int height;

extern void drawtext(LPCSTR text,double x,double y,color_t color=color_normal);
extern void drawtext(LPCSTR text,double x1,double y1,double x2,double y2,color_t color=color_normal,color_t bgcolor=color_fill);
extern void drawstr(std::string str,double x,double y,color_t color=color_normal);
extern void drawstr(std::string str,double x1,double y1,double x2,double y2,color_t color=color_normal,color_t bgcolor=color_fill);
extern void drawint(int i,double x,double y,color_t color=color_normal);
extern void drawint(int i,double x1,double y1,double x2,double y2,color_t color=color_normal,color_t bgcolor=color_fill);
extern void drawdouble(double d,double x,double y,color_t color=color_normal);
extern void drawdouble(double d,double x1,double y1,double x2,double y2,color_t color=color_normal,color_t bgcolor=color_fill);
extern void drawimage(PIMAGE img,double x,double y,int ix1,int iy1,int ix2,int iy2);
extern void drawimagetransparent(PIMAGE img,double x,double y,int ix1,int iy1,int ix2,int iy2);
extern void drawline(double x1,double y1,double x2,double y2,color_t color=color_front);

#endif // _DISPLAY_H_

